<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;

use Doctrine\ORM\EntityRepository;

class Calendar extends EntityRepository {


    public function getCalendarModel($organization){
        $query = $this->getEntityManager()->createQueryBuilder();

        $query->select('c')
            ->from('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar', 'c')
            ->where('c.status = ?1')
            ->setParameter(1, 'A')
            ->andWhere('c.organization= ?2')
            ->setParameter(2,$organization)
            ->andWhere('c.type = ?3')
            ->setParameter(3,'M');


        $result = $query->getQuery()->getArrayResult();
        return $result;

    }
    public function getDataSetForEditProjectCalendar($project,$organization){
        $sql = <<<SQL
       SELECT C.ID ,C.NAME ,C.STATUS ,C.BEGIN_WEEK ,C.END_WEEK ,C.HOUR,TO_CHAR(C.BEGIN_HOUR, 'HH24:MI') AS BEGIN_HOUR,TO_CHAR(C.END_HOUR, 'HH24:MI') AS END_HOUR,C.WEEKLY_HOURS,C.MONTHLY_DAYS
                 FROM PROJECT PRO
                 JOIN CALENDAR C ON (PRO.CALENDAR = C.ID)
                WHERE PRO.ID = :project
                  AND C.ORGANIZATION = :organization
SQL;
        $params = array(
            'project' => $project,
            'organization' => $organization
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql,$params);

    } public function getCalendar($calendarId){
        $sql = <<<SQL
       SELECT CAL.ID,CAL.CALENDAR_DEFAULT
       FROM CALENDAR CAL
       WHERE CAL.ID = :calendar
SQL;
        $params = array(
            'calendar' => $calendarId
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql,$params);

    }


}