<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Repositories;


class CommentType extends \Doctrine\ORM\EntityRepository {

    public function findCommentType($filter) {
        $query = <<<SQL
        SELECT * FROM COMMENT_TYPE
        WHERE STATUS = 'A'
        $filter
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($query);

    }

    public function findCommentTypeByTypeTaskId($issueStatusId) {
        $query = <<<SQL
    SELECT TST.ID AS TASK_STATUS_ID ,COTY.* 
      FROM TASK_TYPE_COMMENT_TYPE TTCT
      JOIN COMMENT_TYPE COTY ON (COTY.ID = TTCT.COMMENT_TYPE_ID )
 LEFT JOIN TASK_STATUS TST ON (TST.TASK_TYPE = TTCT.TASK_TYPE_ID AND TST.USED_IN_ISSUE = 'Y')
     WHERE TTCT.TASK_TYPE_ID = :taskType
       AND TTCT.IN_OUT_COMMENT = :IN_COMMENT
       
SQL;

        $params = array(
            'taskType' => $issueStatusId,
            'IN_COMMENT' => \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskTypeCommentType::IN_COMMENT,
        );
       return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }



    public function findCommentTypeIssueStatus($orgId, $filterString = ''){

        $query = <<<SQL
           SELECT ORGANIZATION_ID ,
                  ID ,
                  STATUS ,
                  NAME ,
                  CONTROL ,
                  ATTACHMENT_REQUIRED
           FROM COMMENT_TYPE
          WHERE ORGANIZATION_ID = :ORG_ID
          $filterString
       ORDER BY NAME
SQL;

        $params = array(
            'ORG_ID' => $orgId
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
}